unit uDemoV4;

{.$MODE Delphi}
{$mode objfpc}{$H+}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ExtDlgs, ComCtrls, Math, uStretchXBRV4, Menus,
  Buttons, FileUtil, //uGifImage,   jpt
  uManipBMPV4;//,
//  axCtrls; //<- pour TOleGraphic;  jpt

type

  { TFrmDemoMain }

  TFrmDemoMain = class(TForm)
    lblScaleValue: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    Page1: TPage;
    SavePictureDialog1: TSavePictureDialog;
    Notebook1: TNotebook;
    PanelHaut: TPanel;
    bAide: TSpeedButton;
    btnDoOpenBMP: TSpeedButton;
    btnSaveBitmap: TSpeedButton;
    labTailleOriginal: TLabel;
    labRedimensionne: TLabel;
    edFileName1: TEdit;
    SpeedButton1: TSpeedButton;
    TrackBar1: TTrackBar;
    GroupBox2: TGroupBox;
    bStretchBlt_HALFTONE: TSpeedButton;
    bStretchBltSansHalftone: TSpeedButton;
    bStretchXBR: TSpeedButton;
    Bevel1: TBevel;
    ProgressBar1: TProgressBar;
    edMis: TEdit;
    Panel2: TPanel;
    Splitter1: TSplitter;
    ScrollBox1: TScrollBox;
    imgOriginal: TImage;
    ScrollBox2: TScrollBox;
    imgResized: TImage;
    imgCarre: TImage;
    bRetour: TSpeedButton;
    labLienURL: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Up_2: TLabel;
    Label7: TLabel;
    imgAAhaut: TImage;
    imgAAbas: TImage;
    Label6: TLabel;
    Label8: TLabel;
    Label11: TLabel;
//    RE1: TRichEdit;
    RE1: TMemo;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
//    RED: TRichEdit; jpt
    RED: TMemo;
    Label19: TLabel;
    bRetour2: TSpeedButton;
    bCoeffs: TSpeedButton;
    Label18: TLabel;
    imgLeft_Up_2: TImage;
    imgDiaTri: TImage;
    imgDiaAst: TImage;
    imgUp_2: TImage;
    imgLeft_2: TImage;
    bAjouterDuFlou: TSpeedButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Label2: TLabel;
    imgZones: TImage;
    Label10: TLabel;
    Label17: TLabel;
    bContraste: TSpeedButton;
    bLuminosite: TSpeedButton;
    bSaturation: TSpeedButton;
    Bevel2: TBevel;
    bDeltaRGB: TSpeedButton;
    ckbSaufGris: TCheckBox;
    ckbVerts: TCheckBox;
    ckbRouges: TCheckBox;
    ckbBleus: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure lblScaleValueClick(Sender: TObject);
    procedure bRetourClick(Sender: TObject);
    procedure bStretchBlt_HALFTONEClick(Sender: TObject);
    procedure bStretchBltSansHalftoneClick(Sender: TObject);
    procedure bStretchXBRClick(Sender: TObject);
    procedure bAideClick(Sender: TObject);
    procedure labLienURLDblClick(Sender: TObject);
    procedure btnDoOpenBMPClick(Sender: TObject);
    procedure btnSaveBitmapClick(Sender: TObject);
    procedure bCoeffsClick(Sender: TObject);
    procedure imgLeft_Up_2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure bAjouterDuFlouClick(Sender: TObject);
    procedure imgZonesMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure bContrasteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bLuminositeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bSaturationMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bDeltaRGBMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Déclarations privées }
    procedure SetScale;
  public
    { Déclarations publiques }
  end;

var
  FrmDemoMain: TFrmDemoMain;

implementation

{$R *.lfm}

var
  aBmp: TBitmap;
  FN: string;
  ScaleValue: Extended = 1.0;
  GTC: DWord;

function ImgFile_To_Bmp(const nomFichierImg: string): tBitMap;
const FormatsSupportes = '.BMP.DIB.GIF.ICO.JIF.JPG.WMF.EMF';
var {OleGraphic: TOleGraphic; jpt} FS: TFileStream; ext: string; img: tImage;
begin if not FileExistsUTF8(nomFichierImg) { *Converti depuis FileExists* } then
  begin
    showMessage(nomFichierImg + ' : n''existe pas'); Result := nil; EXIT;
  end;
  ext := UpperCase(ExtractFileExt(nomFichierImg));
  if (ext = '') or (pos(ext, FormatsSupportes) = 0) then
  begin showMessage(ext + ' = Format non supporté par ImgFile_To_Bmp');
    Result := nil; EXIT;
  end;
  if ext = '.BMP' then
  begin
    Result := tBitmap.create;
    Result.PixelFormat := pf24Bit;
    Result.LoadFromFile(nomFichierImg);
    EXIT;
  end;
//  OleGraphic := TOleGraphic.Create;      jpt
  FS := TFileStream.Create(nomFichierImg, fmOpenRead or fmSharedenyNone);
  img := tImage.Create(Application);
  try
//    OleGraphic.LoadFromStream(FS);        jpt
  //  img.Picture.Assign(OleGraphic);        jpt
    img.Picture.LoadFromStream(FS);       // jpt
    Result := tBitmap.create;
    with Result do
    begin PixelFormat := pf24Bit;
      Width  := img.Picture.Width;
      Height := img.Picture.Height;
      Canvas.Draw(0, 0, img.Picture.Graphic);
    end;
  finally
    fs.Free;
    img.free;
//    OleGraphic.Free;            jpt
  end;
end; // ImgFile_To_Bmp

procedure DoStretchBlt(HalfTon: boolean);
var pt: TPoint; s: string;
begin
  with FrmDemoMain do begin
    edMis.text := ''; edMis.Update;
    GTC := GetTickCount;
// 3 instructions incompatibles avec Linux     jpt
    if HalfTon then begin
//      if GetStretchBltMode(imgResized.Picture.Bitmap.Canvas.Handle) <> HalfTone then
//      begin GetBrushOrgEx(imgResized.Picture.Bitmap.Canvas.Handle, pt);
        SetStretchBltMode(imgResized.Picture.Bitmap.Canvas.Handle, HalfTone);
//        SetBrushOrgEx(imgResized.Picture.Bitmap.Canvas.Handle, pt.x, pt.y, @pt);
//      end;
      s := 'StretchBlt & HALFTONE ';
    end else s := 'StretchBlt SANS HALFTONE ';

    StretchBlt(imgResized.Picture.Bitmap.Canvas.Handle, 0, 0,
      imgResized.Picture.Bitmap.Width, imgResized.Picture.Bitmap.Height,
      imgOriginal.Picture.Bitmap.Canvas.Handle, 0, 0,
      imgOriginal.Picture.Bitmap.Width, imgOriginal.Picture.Bitmap.Height, SRCCOPY);
    edMis.text := s + ', temps : ' + intToStr(GetTickCount - GTC) + ' ms';
    imgResized.Invalidate;
  end;
end;

procedure TFrmDemoMain.bStretchBlt_HALFTONEClick(Sender: TObject);
begin
  Sablier;
  DoStretchBlt(True);
  Sablier;
end;

procedure TFrmDemoMain.bStretchBltSansHalftoneClick(Sender: TObject);
begin
  Sablier;
  DoStretchBlt(False);
  Sablier;
end;

procedure TFrmDemoMain.bStretchXBRClick(Sender: TObject);
begin
  edMis.text := ''; edMis.Update; Sablier;
  GTC := GetTickCount;
  aBmp := StretchXBR(imgOriginal.Picture.Bitmap, ScaleValue, @ProgressBar1.StepIt);
  imgResized.Picture.Bitmap.Assign(aBmp);
  edMis.text := 'StretchXBR, temps : ' + intToStr(GetTickCount - GTC) + ' ms ';
  imgResized.Invalidate;
  ProgressBar1.position := 0;
  Sablier;
  aBmp.free;
  bCoeffs.Enabled := True;
end;

procedure TFrmDemoMain.bAjouterDuFlouClick(Sender: TObject);
var FlouX, FlouY: byte;
begin
  edMis.text := 'Ajout du Flou en cours...'; edMis.Update; Sablier;
  FlouX := 1; FlouY := 1;
  GTC := GetTickCount;
  BmpFlouXY4(imgResized.Picture.Bitmap, FlouX, FlouY, @ProgressBar1.StepIt);
  edMis.text := 'Ajout du flou avec moyenne sur 4 pixels, temps : ' + intToStr(GetTickCount - GTC) + ' ms ';
  imgResized.Invalidate;
  ProgressBar1.position := 0;
  Sablier;
end;

procedure TFrmDemoMain.bContrasteMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var CoefContraste: single;
begin
  //Augmenter/Dimuner le Contraste de  ± 10%
  Sablier; CoefContraste := 0.1;
  GTC := GetTickCount;
  if Button = mbLeft then BmpContraster(imgResized.Picture.Bitmap, -CoefContraste)
  else BmpContraster(imgResized.Picture.Bitmap, +CoefContraste);
  edMis.text := 'Modif du contraste, temps : ' + intToStr(GetTickCount - GTC) + ' ms ';
  Sablier;
  imgResized.Invalidate;
end;

procedure TFrmDemoMain.bLuminositeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  //Augmenter/Dimuner la Luminosité de  ± 10%
  Sablier;
  GTC := GetTickCount;
  if Button = mbLeft then BmpDeltaLuminosite(imgResized.Picture.Bitmap, 1 / 1.1)
  else BmpDeltaLuminosite(imgResized.Picture.Bitmap, 1.1);
  edMis.text := 'Modif luminosité, temps : ' + intToStr(GetTickCount - GTC) + ' ms ';
  Sablier;
  imgResized.Invalidate;
end;

procedure TFrmDemoMain.bSaturationMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  // Augmenter/Diminuer la saturation de 10%
  Sablier;
  GTC := GetTickCount;
  if Button = mbLeft then BmpSatFoisK(imgResized.Picture.Bitmap, 1 / 1.1)
  else BmpSatFoisK(imgResized.Picture.Bitmap, 1.1);
  edMis.text := 'Modif saturation, temps : ' + intToStr(GetTickCount - GTC) + ' ms ';
  Sablier;
  imgResized.Invalidate;
end;

procedure TFrmDemoMain.bDeltaRGBMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var kRouge, kVert, kBleu: single; info: string;
begin //Augmenter/Diminuer une ou des composante(s) R,G,B de 10%
  Sablier; info := 'Modif des ';
  GTC := GetTickCount;
  kRouge := 1.0; kVert := 1.0; kBleu := 1.0;
  if Button = mbLeft then begin
    if ckbRouges.checked then begin kRouge := 1 / 1.1; info := info + ' Rouges,'; end;
    if ckbVerts.checked  then begin kVert  := 1 / 1.1; info := info + ' Verts,';  end;
    if ckbBleus.checked  then begin kBleu  := 1 / 1.1; info := info + ' Bleus,';  end;
  end else begin
    if ckbRouges.checked then begin kRouge := 1.1; info := info + ' Rouges,'; end;
    if ckbVerts.checked  then begin kVert  := 1.1; info := info + ' Verts,';  end;
    if ckbBleus.checked  then begin kBleu  := 1.1; info := info + ' Bleus,';  end;
  end;
  DeltaRGB_Bmp(imgResized.Picture.Bitmap, kRouge, kVert, kBleu, ckbSaufGris.checked);
  edMis.text := info + ', temps : ' + intToStr(GetTickCount - GTC) + ' ms ';
  Sablier;
  imgResized.Invalidate;
end;

procedure TFrmDemoMain.btnDoOpenBMPClick(Sender: TObject);
const Filtre = 'Tous fichiers image (*.bmp;*.gif;*.jpg;*.jpeg;*.ico;*.emf;*.wmf)|*.bmp;*.gif;*.jpg;*.jpeg;*.ico;*.emf;*.wmf)'
  + '|Bitmaps (*.bmp)|*.bmp|CompuServe (*.gif)|*.gif|Fichier image JPEG (*.jpg)|*.jpg|Fichier image JPEG (*.jpeg)|*.jpeg'
    + '|Icônes (*.ico)|*.ico|MétaFichiers évolués (*.emf)|*.emf|MétaFichiers (*.wmf)|*.wmf|Fichiers quelconques (*.*)|*.*';
begin
  OpenPictureDialog1.Filter := Filtre;
  if OpenPictureDialog1.Execute then
  begin
    FN := OpenPictureDialog1.FileName; edFileName1.Text := FN;
    aBmp := TBitmap.Create;
    aBmp := ImgFile_To_Bmp(OpenPictureDialog1.FileName);
    imgOriginal.Picture.Bitmap.Assign(aBmp);
    TrackBar1Change(self);
    TrackBar1.SetFocus;
    aBmp.Free;
  end;
end;

procedure TFrmDemoMain.FormCreate(Sender: TObject);
begin
  aBmp := TBitmap.Create;
  imgResized.Picture.Bitmap := aBmp;
  TrackBar1Change(self);
  // jpt sert à quoi, cette ligne dessous ?
  imgResized.Picture.Bitmap.Canvas.Pixels[0, 0] := imgResized.Picture.Bitmap.Canvas.Pixels[0, 0];
  FN := '';
  bCoeffs.Enabled := False;
  Application.HintHidePause := 10000;
  bAjouterDuFlou.Hint := 'Augmenter le flou : ' + #13#10 + 'Chaque click supplémentaire' + #13#10 + 'renforce le flou précédent';
  bContraste.Hint := '- Augmenter le contraste : click-souris-Droite' + #13#10
    + '- Diminuer le contraste : click-souris-Gauche';
  bLuminosite.Hint := '- Augmenter la luminosité : click-souris-Droite' + #13#10
    + '- Diminuer la luminosité : click-souris-Gauche';
  bSaturation.Hint := '- Augmenter la saturation : click-souris-Droite' + #13#10
    + '- Diminuer la saturation : click-souris-Gauche';
  bDeltaRGB.Hint := 'Composante(s) R,V,B : ' + #13#10
    + '- Augmenter : click-souris-Droite' + #13#10
    + '- Diminuer : click-souris-Gauche';
end;

procedure TFrmDemoMain.lblScaleValueClick(Sender: TObject);
begin
  TrackBar1.SetFocus;
end;

procedure TFrmDemoMain.SetScale;
begin
  imgResized.Picture.Bitmap.Width  := Round(imgOriginal.Picture.Bitmap.Width * ScaleValue);
  imgResized.Picture.Bitmap.Height := Round(imgOriginal.Picture.Bitmap.Height * ScaleValue);
  ProgressBar1.Max := imgResized.Picture.Bitmap.Height;
  ProgressBar1.Position := 0;
end;

procedure TFrmDemoMain.Splitter1Moved(Sender: TObject);
begin
  labRedimensionne.Left := ScrollBox2.Left + 6;
end;

procedure TFrmDemoMain.TrackBar1Change(Sender: TObject);
begin
  ScaleValue := TrackBar1.Position / 100;
  SetScale;
  lblScaleValue.Caption := Format('%d%%   k =%f', [TrackBar1.Position, Scalevalue]);
  labTailleOriginal.Caption := Format('Taille de l''original: %dx%d pixels', [imgOriginal.Picture.Bitmap.Width, imgOriginal.Picture.Bitmap.Height]);
  labRedimensionne.Caption  := Format('Redimensionné à %s : %dx%d pixels', [lblScaleValue.Caption, imgResized.Picture.Bitmap.Width, imgResized.Picture.Bitmap.Height]);
  bCoeffs.Enabled := False;
end;

procedure TFrmDemoMain.btnSaveBitmapClick(Sender: TObject);
const nf = 'XBR_Redimensionné.bmp';
var nfc: string;
begin
  with SavePictureDialog1 do begin
    Filter := 'Fichier *.bmp|*.bmp)';
    if FN = '' then FileName := nf else
    begin
      nfc := extractFileName(FN);
      nfc := ChangeFileExt(nfc, '.bmp');
      FileName := 'Redimensionné_' + nfc;
    end;
    if Execute then begin
      imgResized.Picture.Bitmap.SaveToFile(FileName);
    end;
  end;
end;

procedure TFrmDemoMain.bAideClick(Sender: TObject);
begin
//  NoteBook1.ActivePage := 'pageInfos';   jpt
  NoteBook1.Page[1].Show;
  NoteBook1.Page[0].Hide;
  NoteBook1.Page[2].Hide;
end;

procedure TFrmDemoMain.bCoeffsClick(Sender: TObject);
begin
//  NoteBook1.ActivePage := 'pageCoeffs';  jpt
  NoteBook1.Page[2].Show;
  NoteBook1.Page[0].Hide;
  NoteBook1.Page[1].Hide;
end;

procedure TFrmDemoMain.bRetourClick(Sender: TObject);
begin
//  NoteBook1.ActivePage := 'pageDéfaut';  jpt
  NoteBook1.Page[0].Show;
  NoteBook1.Page[1].Hide;
  NoteBook1.Page[2].Hide;
end;

procedure TFrmDemoMain.labLienURLDblClick(Sender: TObject);
begin
  OpenDocument(PChar(labLienURL.Caption)); { *Converti depuis ShellExecute* }
end;

procedure TFrmDemoMain.imgLeft_Up_2MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var img: tImage;
begin
  img := (sender as tImage);
  with img do begin
    if (x > 4) and (x < 40) and (y > 4) and (y < 40) then
    begin width := 56; height := 56; end else
    begin width := 40; height := 40; end;
  end;
end;

procedure TFrmDemoMain.imgZonesMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  with imgZones do begin
    if (x > 10) and (x < 330) and (y > 10) and (y < 230) then
    begin width := round(330 * 1.45); height := round(230 * 1.45); end else
    begin width := 330; height := 230; end;
  end;

end;

end. ///////////////////////////////////////////////////////////////////////////

