unit uStretchXBRV4;

{.$MODE Delphi}
{$mode objfpc}{$H+}

//   Redimensionner un BitMap avec la méthode XBR pour un facteur d'échelle de valeur quelconque
//   Code expérimental - Version 3
//   Développé sous Delphi-5
//   Gilbert GEYER, novembre 2012
//   Développé par une série de modifications du XBR4bis de Barbichette
// jpt : marche pas... téléchargeable ici : http://www.delphifr.com/codes/REDIMENSIONNEMENT-XBR_54505.aspx
//   Pour la théorie du XBR voir ici : http://board.byuu.org/viewtopic.php?f=10&t=2248
// jpt, 2/2019 : lien mort... :-(

interface

uses LCLIntf, LCLType, LMessages, Math, Graphics, Sysutils, Dialogs, Classes, Forms, Controls, uManipBMPV4;

function StretchXBR(const BmpS: tBitMap; ScaleFactor: Single; const ProgressCallBack: TObjectProc = nil): tBitMap;
procedure Sablier;

implementation

uses uDemoV4;

// A) UTILITAIRES DIVERS

function ToucheCla(t: integer): boolean; // détection Appui Touche-clavier ou Touche-Souris
//       utilisations : if ToucheCla(VK_CONTROL) then ...
//                      if ToucheCla(Ord('R')) then ...
begin ////Result := ((GetAsyncKeyState(t) and 32768) <> 0);
end;

procedure Sablier;
begin
  with Screen do if cursor = crHourGlass then cursor := crDefault else cursor := crHourGlass;
end;

// B) Méthode XBR pour un ScaleFoctor de valeur quelconque ---------------------

function StretchXBR(const BmpS: tBitMap; ScaleFactor: Single; const ProgressCallBack: TObjectProc = nil): tBitMap;
label Achever;
type
  tScanYX  = array of array of integer; // Tableau des adresses des pixels
  Tvoisins = array[-2..2, -2..2] of tRGBQuad; // Matrice des couleurs voisines du pixel-source
  tCoeffs  = array of array of Single; // Matrice des coefficients de pondération pour dégradés de couleurs
const
  R2: Single = 1.41421356737; // racine carrée de 2
  pg_red_mask   = $FF0000;
  pg_green_mask = $00FF00;
  pg_blue_mask  = $0000FF;
var
  xs, ys, xoutMin, youtMin, ixr, iyr, Lig, Col: integer;
  Voisins: Tvoisins;

  Rouge, Bleu, Vert, Jaune, Fuchsia, Aqua: tRGBQuad; // Couleurs utilisées en conception pour repérer les zones touches
  clPixOut: tRGBQuad;
  kech: Single; // coefficient d'échelle
  ikech: integer; // coefficient d'échelle
  mikech: Single; // moitié du coefficient d'échelle
  kDiaTri, kDiaAst, kUP_2, kLeft_2, kLeft_UP_2, kTmpRota: tCoeffs; // Matrices des coefficients de pondération pour dégradés de couleurs

  WS, HS: integer; pt: TPoint;
  WR, HR: integer;

  pixS, pixR: tScanYX;

  procedure Initialisations; // Initialisation des BitMaps et des paramètres constants
  var x, y: integer;
    Scan0: Integer; // Valeur du pointeur d'entrée dans le Bitmap.
    MLS: Integer; //   Memory Line Size (en bytes) du Bitmap.
    Bpp: Integer; //   Bytes par pixel des Bitmaps.
    dx, dy, Rm, Ri, kechR2, depb: Single; s: string;
  begin
    Kech := iKech;
    miKech := Kech / 2;
    kechR2 := Kech * R2;
    // BitMap-Source
//    BmpS.PixelFormat := pf32bit; // jpt : je commente car sinon, ça détruit l'original
// évidemment tout est en vrac derrière...
    Bpp := 4;
    Scan0 := Integer(BmpS.ScanLine[0]);
    MLS := Integer(BmpS.ScanLine[1]) - Scan0;
    WS := BmpS.Width; HS := BmpS.Height;
    SetLength(pixS, HS, WS);
    for y := 0 to HS - 1 do begin
      for x := 0 to WS - 1 do pixS[y, x] := Scan0 + y * MLS + x * Bpp;
    end;
    // BitMap-result
    Result := tBitMap.Create; kech := abs(kech);
    WR := iKech * WS; HR := iKech * HS;
    with Result do begin PixelFormat := pf32bit; width := WR; height := HR end;
    Scan0 := Integer(Result.ScanLine[0]);
    MLS   := Integer(Result.ScanLine[1]) - Scan0;
    SetLength(pixR, HR, WR);
    for y := 0 to HR - 1 do begin
      for x := 0 to WR - 1 do begin
        pixR[y, x] := Scan0 + y * MLS + x * Bpp;
        PRGBQuad(pixR[y, x])^ := ColorVersClQuad(clWhite);
//        PRGBQuad(pixR[y, x])^.rgbReserved := 0; // jpt
        PRGBQuad(pixR[y, x])^.rgbReserved := 255;
      end;
    end;
    Rouge   := ColorVersClQuad(clRed);
    Bleu    := ColorVersClQuad(clBlue);
    Vert    := ColorVersClQuad(clGreen);
    Jaune   := ColorVersClQuad(clYellow);
    Fuchsia := ColorVersClQuad(clFuchsia);
    Aqua    := ColorVersClQuad(clAqua);

    // Précalculs des coefficients de pondération pour dégradés :
    // Initialisations pour les Coins Sud-Est :

    //¨ Left_UP_2 Version Quart d'Astroïde ("triangle" avec hypothénuse en arc de cercle)
    SetLength(kLeft_UP_2, iKech, iKech);
    dy := 0.0; Rm := kech - 1.0;
    while dy < Kech do begin
      dx := 0.0;
      while dx < Kech do begin
        y := trunc(dy); x := trunc(dx);
        Ri := Hypot(dx, dy);
        if Ri >= Rm then begin
          kLeft_UP_2[y, x] := (Ri - Rm) / (kechR2 - Rm); // Coin dégradé en arcs de cercle
          if kLeft_UP_2[y, x] > 1.0 then kLeft_UP_2[y, x] := 1.0;
        end else kLeft_UP_2[y, x] := 0.0;
        dx := dx + 0.25;
      end;
      dy := dy + 0.25;
    end;
    // DIA version Triangulaire :
    SetLength(kDiaTri, iKech, iKech);
    dy := 0.0;
    while dy < Kech do begin
      dx := 0.0;
      while dx < Kech do begin
        y := trunc(dy); x := trunc(dx);
        if (dx + dy >= 1.5 * kech) then begin
          depb := dx + dy - 1.5 * kech;
          // Epaisseur dégradée du bord du coin = 1 pixel ici
          if depb <= 1 then kDiaTri[y, x] := 0.5 else kDiaTri[y, x] := 1.0;
        end else kDiaTri[y, x] := 0.0;
        dx := dx + 0.25;
      end;
      dy := dy + 0.25;
    end;

    // DIA Version Quart d'Astroïde décentré d'un pixel :
    SetLength(kDiaAst, iKech, iKech);
    dy := 0.0; Rm := mikech + 1;
    while dy < Kech do begin
      dx := 0.0;
      while dx < Kech do begin
        y := trunc(dy); x := trunc(dx);
        Ri := Hypot(dx - mikech + 1, dy - mikech + 1);
        if (Ri >= Rm) and (dx >= miKech - 1) and (dy >= miKech - 1) then begin
          kDiaAst[y, x] := (Ri - Rm) / (Rm * R2 - Rm);
        end else kDiaAst[y, x] := 0.0;
        dx := dx + 0.25;
      end;
      dy := dy + 0.25;
    end;
    kDiaAst[iKech - 1, iKech - 1] := 1.0;

    // Up_2 Version Triangulaire :
    SetLength(kUP_2, iKech, iKech);
    dy := 0.0;
    while dy < Kech do begin
      dx := 0.0;
      while dx < Kech do begin
        y := trunc(dy); x := trunc(dx);
        if (2 * dy + dx >= 2 * kech) then begin
          depb := 2 * dy + dx - 2.0 * kech;
          // Epaisseur dégradée du bord du coin = 1 pixel ici :
          if depb <= 1 then kUP_2[y, x] := 0.5 else kUP_2[y, x] := 1.0;
        end else kUP_2[y, x] := 0.0;
        dx := dx + 0.25;
      end;
      dy := dy + 0.25;
    end;

    // Left_2 Version Triangulaire :
    SetLength(kLeft_2, iKech, iKech);
    dy := 0.0;
    while dy < Kech do begin
      dx := 0.0;
      while dx < Kech do begin
        y := trunc(dy); x := trunc(dx);
        if (2 * dx + dy >= 2 * kech) then begin
          depb := 2 * dx + dy - 2.0 * kech;
          // Epaisseur dégradée du bord du coin = 1 pixel ici :
          if depb <= 1 then kLeft_2[y, x] := 0.5 else kLeft_2[y, x] := 1.0;
        end else kLeft_2[y, x] := 0.0;
        dx := dx + 0.25;
      end;
      dy := dy + 0.25;
    end;

    SetLength(kTmpRota, iKech, iKech);

    // Affichage des coeffs :
    with FrmDemoMain.RED do begin  // jpt richedit, merdum... Passé en TMemo = ok
      Clear;
      Lines.Add('kLeft_UP_2 :'); s := '';
      for y := 0 to ikech - 1 do begin
        for x := 0 to ikech - 1 do s := s + '  ' + FloatToStrF(kLeft_UP_2[y, x], ffFixed, 7, 3);
        Lines.Add('y = ' + intToStr(y) + ' -> K = ' + s);
        s := '';
      end;
      Lines.Add(#13#10 + 'kDiaTri :'); s := '';
      for y := 0 to ikech - 1 do begin
        for x := 0 to ikech - 1 do s := s + '  ' + FloatToStrF(kDiaTri[y, x], ffFixed, 7, 3);
        Lines.Add('y = ' + intToStr(y) + ' -> K = ' + s);
        s := '';
      end;
      Lines.Add(#13#10 + 'kDiaAst :'); s := '';
      for y := 0 to ikech - 1 do begin
        for x := 0 to ikech - 1 do s := s + '  ' + FloatToStrF(kDiaAst[y, x], ffFixed, 7, 3);
        Lines.Add('y = ' + intToStr(y) + ' -> K = ' + s);
        s := '';
      end;
      Lines.Add(#13#10 + 'kUP_2 :'); s := '';
      for y := 0 to ikech - 1 do begin
        for x := 0 to ikech - 1 do s := s + '  ' + FloatToStrF(kUP_2[y, x], ffFixed, 7, 3);
        Lines.Add('y = ' + intToStr(y) + ' -> K = ' + s);
        s := '';
      end;
      Lines.Add(#13#10 + 'kLeft_2 :'); s := '';
      for y := 0 to ikech - 1 do begin
        for x := 0 to ikech - 1 do s := s + '  ' + FloatToStrF(kLeft_2[y, x], ffFixed, 7, 3);
        Lines.Add('y = ' + intToStr(y) + ' -> K = ' + s);
        s := '';
      end;
    end;
  end; // Initialisations

  function RGBtoYUV(c: longint): longint;
  //       Conversion de l'espace colorimétrique RGB vers l'espace YUV
  var r, g, b, y, u, v: cardinal;
  begin
    r := (c and pg_red_mask)   shr 16;
    g := (c and pg_green_mask) shr 8;
    b := (c and pg_blue_mask);
    y := ((r shl 4) + (g shl 5) + (b shl 2)); // Y = Luminance
    u := (-r - (g shl 1) + (b shl 2)); // U et V = Chrominance
    v := ((r shl 1) - (g shl 1) - (b shl 1));
    result := y + u + v;
  end;

  function ClQuadVerscLongint(c: tRGBQuad): longint;
  // Simple conversion d'une couleur du type RGBQuad vers le type longint utilisé par RGBtoYUV
  begin
    Result := (c.rgbRed shl 16) + (c.rgbGreen shl 8) + c.rgbBlue;
  end;

  function df(A, B: tRGBQuad): longint;
  var AL, BL: longint;
  begin
    AL := ClQuadVerscLongint(A); BL := ClQuadVerscLongint(B);
    result := abs(RGBtoYUV(Al) - RGBtoYUV(BL));
    // Result renvoie une valeur qui augmente lorsque la couleur A contraste de plus en plus avec celle de la couleur B
    // Result-maxi = 13005 dans le cas d'un contraste maxi Noir/Blanc.
  end;

  function eq(A, B: tRGBQuad): boolean;
  begin
    result := df(A, B) < 155;
  end;

  function ifThenClQuad(condition: boolean; OK: tRGBQuad; NOK: tRGBQuad): tRGBQuad;
  begin
    if condition then result := OK else result := NOK;
  end;

  procedure RotateVoisins; //paramètre matrice: Tvoisins,  Rotation de la matrice des couleurs voisines dans le sens des aiguilles d'une montre.
  var tmp: Tvoisins; Co, Li: integer;
  begin
    for Li := -2 to 2 do
      for Co := -2 to 2 do
        tmp[-Li, Co] := Voisins[Co, Li];
    Voisins := tmp;
  end;

  procedure RotateCoeffs; // Rotation des matrices de coefficients de pondération pour le traitement des angles
  var Co, Li: integer;
  begin
    // kLeft_UP_2 :
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kTmpRota[Co, iKech - Li - 1] := kLeft_UP_2[Li, Co];
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kLeft_UP_2[Li, Co] := kTmpRota[Li, Co];

    // kDiaTri :
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kTmpRota[Co, iKech - Li - 1] := kDiaTri[Li, Co];
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kDiaTri[Li, Co] := kTmpRota[Li, Co];

    // kDiaAst :
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kTmpRota[Co, iKech - Li - 1] := kDiaAst[Li, Co];
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kDiaAst[Li, Co] := kTmpRota[Li, Co];

    // kUP_2 :
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kTmpRota[Co, iKech - Li - 1] := kUP_2[Li, Co];
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kUP_2[Li, Co] := kTmpRota[Li, Co];

    // kLeft_2 :
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kTmpRota[Co, iKech - Li - 1] := kLeft_2[Li, Co];
    for Li := 0 to iKech - 1 do
      for Co := 0 to iKech - 1 do kLeft_2[Li, Co] := kTmpRota[Li, Co];
  end; // RotateCoeffs;

  procedure SetPixelOut; //paramètres : ixr,iyr: integer; clPixOut: tRGBQuad
  begin
    if (ixr >= 0) and (iyr >= 0) and (ixr < WR) and (iyr < HR) then PRGBQuad(pixR[iyr, ixr])^ := clPixOut;
  end;

  procedure TracerCoin(xx, yy: integer; Coin: tCoeffs; nc: tRGBQuad);
  //        Dégradé de couleurs dans le coin correspondant s'il a été détecté un bord à 63,43° le nécessitant
  //        nc = Nouvelle couleur
  var x, y: integer;
  begin
    for y := 0 to iKech - 1 do begin
      for x := 0 to iKech - 1 do begin
        if Coin[x, y] <> 0.0 then begin
          clPixOut := clQuadMix2K(nc, voisins[0, 0], Coin[x, y]);
          ixr := xx + x; iyr := yy + y;
          SetPixelOut;
          // Pour repérage éventuel des zones touchées :
          { if Coin = kLeft_UP_2 then clPixOut := Vert else
            if Coin = kDiaTri then clPixOut := Rouge else
              if Coin = kDiaAst then clPixOut := Aqua else
                if Coin = kUp_2 then clPixOut := Bleu else
                  if Coin = kLeft_2 then clPixOut := Fuchsia;
          SetPixelOut; }
        end;
      end;
    end;
    //ixr := xx + (iKech shr 1); iyr := yy + (iKech shr 1); clPixOut:=nc; SetPixelOut; //< pour repérage éventuel de la couleur nc
  end; // TracerCoin

  procedure FILTRE_KXBR(v: Tvoisins);
  var
    ex2, ex3: boolean;
    le, li: integer;
    ke, ki: integer; px: tRGBQuad;
  begin
    // les voisins sont-ils de la même couleur ?
    // si oui, on ne fait rien : le carré reste entièrement de la même couleur que le voisins[0, 0]
    if (clQuadEgales(v[0, 0], v[0, 1])) or (clQuadEgales(v[0, 0], v[1, 0])) then EXIT;
    // si non, recherche des bords :

    le := (df(v[1, -1], v[0, 0]) + df(v[0, 0], v[-1, 1]) + df(v[0, 2], v[1, 1]) + df(v[1, 1], v[2, 0])) + (df(v[0, 1], v[1, 0]) shl 2);
    li := (df(v[-1, 0], v[0, 1]) + df(v[0, 1], v[1, 2]) + df(v[0, -1], v[1, 0]) + df(v[1, 0], v[2, 1])) + (df(v[0, 0], v[1, 1]) shl 2);
    // si le < li : bord globalement du bas gauche vers haut droit : Sud-Est
    // les autres sens seront traité lors des rotations

    if (le < li) and ((not eq(v[1, 0], v[0, -1]) and not eq(v[1, 0], v[1, -1]))
      or (not eq(v[0, 1], v[-1, 0]) and not eq(v[0, 1], v[-1, 1]))
      or (eq(v[0, 0], v[1, 1])
      and ((not eq(v[1, 0], v[2, 0]) and not eq(v[1, 0], v[2, 1]))
      or (not eq(v[0, 1], v[0, 2]) and not eq(v[0, 1], v[1, 2]))))
      or eq(v[0, 0], v[-1, 1])
      or eq(v[0, 0], v[1, -1])) then
    begin
      ke := df(v[1, 0], v[-1, 1]);
      ki := df(v[0, 1], v[1, -1]);
      ex2 := (not clQuadEgales(v[0, 0], v[1, -1])) and (not clQuadEgales(v[0, -1], v[1, -1]));
      ex3 := (not clQuadEgales(v[0, 0], v[-1, 1])) and (not clQuadEgales(v[-1, 0], v[-1, 1]));

      // On choisit la nouvelle couleur à appliquer
      px := ifThenClQuad((df(v[0, 0], v[1, 0]) <= df(v[0, 0], v[0, 1])), v[1, 0], v[0, 1]);

      if ((ke shl 1) <= ki) and ex3 and (ke >= (ki shl 1)) and ex2 then
      begin // LEFT_UP_2
        TracerCoin(xoutMin, youtMin, kLeft_UP_2, px);
      end else
        if ((ke shl 1) <= ki) and ex3 then
        begin // LEFT_2
          TracerCoin(xoutMin, youtMin, kLEFT_2, px);
        end else
          if (ke >= (ki shl 1)) and ex2 then
          begin // UP_2
            TracerCoin(xoutMin, youtMin, kUP_2, px);
          end else
          begin // DIA Triangulaire
            TracerCoin(xoutMin, youtMin, kDiaTri, px);
          end
    end else
      if le <= li then begin // Pointes d'angles : DIA Quart d'Astéroïde
        px := ifThenClQuad(df(v[0, 0], v[1, 0]) <= df(v[0, 0], v[0, 1]), v[1, 0], v[0, 1]);
        TracerCoin(xoutMin, youtMin, kDiaAst, px);
      end;
  end; // FILTRE_KX

  function getPixelIn(xx, yy: integer): tRGBQuad;
  begin
    if xx < 0 then xx := 0;
    if yy < 0 then yy := 0;
    if xx >= WS then xx := WS - 1;
    if yy >= HS then yy := HS - 1;
    result := PRGBQuad(pixS[yy, xx])^;
  end;

begin
  ScaleFactor := abs(ScaleFactor);
  if ScaleFactor <= 1.0 then begin // Si ScaleFactor <= 1.0 XBR n'apporte rien donc simple réduction de taille rapide avec StretchBlt
    Result := tBitMap.Create;
//    BmpS.PixelFormat := pf32bit; // jpt : je commente car sinon, ça détruit l'original
// évidemment tout est en vrac derrière...
    Result.Assign(BmpS);
    iKech := round(ScaleFactor);
    goto Achever;
  end else // sinon utilisation du XBR :
    if ScaleFactor >= 8.0 then Kech := Scalefactor
    else Kech := 8.0; // Si ScaleFactor < 8.0 on procède à un XBR avec 8 et qui sera suivi d'un ajustement de taille rapide avec StretchBlt
  iKech := round(Kech);

  Initialisations;

  for ys := 0 to HS - 1 do begin
    for xs := 0 to WS - 1 do begin

// jpt : à tester, d'habitude c'est plutôt for x := -1 to 2
      for Col := -2 to 2 do
        for Lig := -2 to 2 do begin
          voisins[Col, Lig] := getPixelIn(xs + Col, Lig + ys);
        end;

      xoutMin := xs * ikech; youtMin := ys * ikech; // Angle Supérieur Gauche du carré à traiter

      for Col := 0 to iKech - 1 do // Tracé préalable du carré plein monochrome Avant recherche de bords éventuels
        for Lig := 0 to iKech - 1 do begin
          ixr := xoutMin + Col; iyr := youtMin + Lig; clPixOut := voisins[0, 0];
          SetPixelOut; //SetPixelOut utilise ixr, iyr, clPixOut
        end;

      FILTRE_KXBR(voisins);
      RotateVoisins; RotateCoeffs;
      FILTRE_KXBR(voisins);
      RotateVoisins; RotateCoeffs;
      FILTRE_KXBR(voisins);
      RotateVoisins; RotateCoeffs;
      FILTRE_KXBR(voisins);
      RotateCoeffs;
      //ixr:=xoutMin; iyr:=youtMin; clPixOut:=Rouge; SetPixelOut; //<- Pour Visu éventuelle de la Trame
    end;
    if ToucheCla(VK_ESCAPE) then EXIT;
    if Assigned(ProgressCallBack) then ProgressCallBack;
  end;
  Achever:
  if iKech <> ScaleFactor then begin // Ajustement de taille si ScaleFactor n'est pas une valeur entière ou s'il est inférieur à 8
//jpt    GetBrushOrgEx(Result.Canvas.Handle, pt);
    SetStretchBltMode(Result.Canvas.Handle, HalfTone);
//jpt    SetBrushOrgEx(Result.Canvas.Handle, pt.x, pt.y, @pt);

    WR := round(ScaleFactor * bmpS.Width); HR := round(ScaleFactor * bmpS.Height);
    StretchBlt(Result.Canvas.Handle, 0, 0, WR, HR,
      Result.Canvas.Handle, 0, 0, Result.Width, Result.height, SRCCOPY);
    with Result do begin Width := WR; height := HR; end;
  end;
  SetLength(pixS, 0, 0); SetLength(pixR, 0, 0);
end; // StretchXBR

end. ///////////////////////////////////////////////////////////////////////////

